package com.benyanyi.loglib;

import ohos.hiviewdfx.HiLog;
import ohos.hiviewdfx.HiLogLabel;

import java.io.*;
import java.util.Random;

/**
 * @author myLove
 * @time 2017/10/31 10:40
 * @e-mail mylove.520.y@gmail.com
 * @overview
 */

class FileLog {
    private static final String FILE_PREFIX = "JLog_";
    private static final String FILE_FORMAT = ".log";

    static void printFile(String tag, File targetDirectory, String fileName, String headString, String msg) {

        fileName = (fileName == null) ? getFileName() : fileName;
        if (save(targetDirectory, fileName, msg)) {
            HiLog.debug(new HiLogLabel(HiLog.LOG_APP, 0x100, tag), headString + " save log success ! location is >>>" + targetDirectory.getAbsolutePath() + "/" + fileName);
        } else {
            HiLog.debug(new HiLogLabel(HiLog.LOG_APP, 0x100, tag), headString + "save log fails !");
        }
    }

    private static boolean save(File dic, String fileName, String msg) {

        File file = new File(dic, fileName);

        try {
            OutputStream outputStream = new FileOutputStream(file);
            OutputStreamWriter outputStreamWriter = new OutputStreamWriter(outputStream, "UTF-8");
            outputStreamWriter.write(msg);
            outputStreamWriter.flush();
            outputStream.close();
            return true;
        } catch (Exception e) {
            e.printStackTrace();
            return false;
        }

    }

    private static String getFileName() {
        Random random = new Random();
        return FILE_PREFIX + Long.toString(System.currentTimeMillis() + random.nextInt(10000)).substring(4) + FILE_FORMAT;
    }
}
